码迷,mamicode.com
首页 > 其他好文 > 详细

Codeforces 841D Leha and another game about graph - 差分

时间:2017-08-21 23:03:37      阅读:422      评论:0      收藏:0      [点我收藏+]

标签:ever   add   pre   computer   ati   ...   有用   bool   限制   

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 01 or  - 1. To pass the level, he needs to find a «good» subset of edges of the graph or say, that it doesn‘t exist. Subset is called «good», if by by leaving only edges from this subset in the original graph, we obtain the following: for every vertex i, di =  - 1 or it‘s degree modulo 2 is equal to di. Leha wants to pass the game as soon as possible and ask you to help him. In case of multiple correct answers, print any of them.

Input

The first line contains two integers nm (1 ≤ n ≤ 3·105n - 1 ≤ m ≤ 3·105) — number of vertices and edges.

The second line contains n integers d1, d2, ..., dn ( - 1 ≤ di ≤ 1) — numbers on the vertices.

Each of the next m lines contains two integers u and v (1 ≤ u, v ≤ n) — edges. It‘s guaranteed, that graph in the input is connected.

Output

Print  - 1 in a single line, if solution doesn‘t exist. Otherwise in the first line k — number of edges in a subset. In the next k lines indexes of edges. Edges are numerated in order as they are given in the input, starting from 1.

Examples
input
1 0
1
output
-1
input
4 5
0 0 0 -1
1 2
2 3
3 4
1 4
2 4
output
0
input
2 1
1 1
1 2
output
1
1
input
3 3
0 -1 1
1 2
2 3
1 3
output
1
2
Note

In the first sample we have single vertex without edges. It‘s degree is 0 and we can not get 1.


  题目大意 给定一个不包含自环的连通图,从中选出一些边使得特定的点满足入度的奇偶性。

  这里主要的问题是要处理要求入度为奇数的点(入度为偶数的点可以不连任何边)。然后仔细研究会发现,一条路径除了两端的点增加的度数为奇数,中间经过的点增加的度数都为偶数,这就很有用了。

  现在就考虑用一堆起点和终点(其实只用将要求度数为奇数的点任选两个配对,再选剩下中的两个,以此内推)都是要求入度为奇数的路径把它们的边集异或(因为当两条路径有一条公共的边后就会出事情,所以需要把这条边删掉)后得到的新的边集一定是合法的吗?(当然所有选择的点包含了所有要求入度为奇数的点)

  当要求度数为1的点的个数为奇数的时候就不一定了。因为总会存在一个点不满足要求。那么这时候就是没有限制的点的表演时间,就找一条路径把1个没有限制的点和这个点连接起来,路上的边的选择情况异或一下。

  至于如何快速搞定这个一堆边集取反的过程呢?

  首先考虑如果最终得到的图形上出现圈是否有意义?

  答案是没有意义,这一圈的边全都可以去掉,因为圈 = 首位相连的路径,这将意味着圈上任意点的度数加了2,这对奇偶性没有影响,是多余的,可以去掉。

  所以我们选择每条路径的起点和终点的时候都要求它们不同,所以最终得到的图形是森林。既然是在树上,就可以干很多事情了,比如树上差分。

  然后把对 边的取反信息 下放到子节点上(dfs树上),接着从任意一点进行一次dfs就好了。

Code

 1 /**
 2  * Codeforces
 3  * Problem#431D
 4  * Accepted
 5  * Time: 405ms
 6  * Memory: 41000k
 7  */
 8 #include <bits/stdc++.h>
 9 using namespace std;
10 typedef bool boolean;
11 
12 int n, m;
13 int *gs;
14 int *rev;
15 vector<int> *g;
16 vector<int> *ig;
17 vector<int> c1, c2;
18 
19 inline void init() {
20     scanf("%d%d", &n, &m);
21     g = new vector<int>[n + 1];
22     ig = new vector<int>[n + 1];
23     gs = new int[(n + 1)];
24     rev = new int[(n + 1)];
25     memset(rev, 0, sizeof(int) * (n + 1));
26     for(int i = 1; i <= n; i++) {
27         scanf("%d", gs + i);
28         if(gs[i] == 1)
29             c1.push_back(i);
30         else if(gs[i] == -1)
31             c2.push_back(i);
32     }
33     for(int i = 1, u, v; i <= m; i++) {
34         scanf("%d%d", &u, &v);
35         g[u].push_back(v);
36         g[v].push_back(u);
37         ig[u].push_back(i);
38         ig[v].push_back(i);
39     }
40 }
41 
42 vector<int> res;
43 boolean *vis;
44 void dfs(int node) {
45     vis[node] = true;
46     for(int i = 0; i < (signed)g[node].size(); i++) {
47         int& e = g[node][i];
48         if(vis[e])    continue;
49         dfs(e);
50         if(rev[e])    res.push_back(ig[node][i]);
51         rev[node] ^= rev[e];
52     }
53 }
54 
55 inline void solve() {
56     int sc1 = (signed)c1.size(), sc2 = (signed)c2.size();
57     if((sc1 & 1) && !sc2) {
58         puts("-1");
59         return;
60     }
61     vis = new boolean[(n + 1)];
62     memset(vis, false, sizeof(boolean) * (n + 1));
63     for(int i = 1; i < sc1; i += 2)
64         rev[c1[i]] = rev[c1[i - 1]] = 1;
65     if(sc1 & 1)
66         rev[c1[sc1 - 1]] = rev[c2[0]] = 1;
67     dfs(1);
68     sc1 = (signed)res.size();
69     printf("%d\n", sc1);
70     for(int i = 0; i < sc1; i++)
71         printf("%d\n", res[i]);
72 }
73 
74 int main() {
75     init();
76     solve();
77     return 0;
78 }

Codeforces 841D Leha and another game about graph - 差分

标签:ever   add   pre   computer   ati   ...   有用   bool   限制   

原文地址:http://www.cnblogs.com/yyf0309/p/7407008.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!